# Uses of Interface
org.springframework.http.server.reactive.ServerHttpRequest

Packages that use ServerHttpRequest
Package
Description
org.springframework.http.codec
Provides implementations of `Encoder` and `Decoder` for web use.
org.springframework.http.codec.json
JSON encoder and decoder support.
org.springframework.http.server.reactive
Abstractions for reactive HTTP server support including a `ServerHttpRequest` and `ServerHttpResponse` along with an `HttpHandler` for processing.
org.springframework.http.server.reactive.observation
Instrumentation for `observing` reactive HTTP server applications.
org.springframework.web.cors.reactive
Reactive support for CORS (Cross-Origin Resource Sharing), based on a common `CorsProcessor` strategy.
org.springframework.web.filter.reactive
`WebFilter` implementations for use in reactive web applications.
org.springframework.web.server
Core interfaces and classes for Spring's generic, reactive web support.
org.springframework.web.server.adapter
Implementations to adapt to the underlying `org.springframework.http.client.reactive` reactive HTTP adapter and `HttpHandler`.

## Uses of ServerHttpRequest in org.springframework.http.codec

Methods in org.springframework.http.codec with parameters of type ServerHttpRequest
Modifier and Type
Method
Description
`Map<String,Object>`
HttpMessageDecoder.`getDecodeHints(org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, ServerHttpRequest request, ServerHttpResponse response)`
Get decoding hints based on the server request or annotations on the target controller method parameter.
`default Map<String,Object>`
HttpMessageEncoder.`getEncodeHints(org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, MediaType mediaType, ServerHttpRequest request, ServerHttpResponse response)`
Get decoding hints based on the server request or annotations on the target controller method parameter.
`protected Map<String,Object>`
DecoderHttpMessageReader.`getReadHints(org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, ServerHttpRequest request, ServerHttpResponse response)`
Get additional hints for decoding for example based on the server request or annotations from controller method parameters.
`protected Map<String,Object>`
ResourceHttpMessageReader.`getReadHints(org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, ServerHttpRequest request, ServerHttpResponse response)`
`protected Map<String,Object>`
EncoderHttpMessageWriter.`getWriteHints(org.springframework.core.ResolvableType streamType, org.springframework.core.ResolvableType elementType, MediaType mediaType, ServerHttpRequest request, ServerHttpResponse response)`
Get additional hints for encoding for example based on the server request or annotations from controller method parameters.
`reactor.core.publisher.Flux<T>`
DecoderHttpMessageReader.`read(org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, ServerHttpRequest request, ServerHttpResponse response, Map<String,Object> hints)`
`default reactor.core.publisher.Flux<T>`
HttpMessageReader.`read(org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, ServerHttpRequest request, ServerHttpResponse response, Map<String,Object> hints)`
Server-side only alternative to `HttpMessageReader.read(ResolvableType, ReactiveHttpInputMessage, Map)` with additional context available.
`reactor.core.publisher.Mono<T>`
DecoderHttpMessageReader.`readMono(org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, ServerHttpRequest request, ServerHttpResponse response, Map<String,Object> hints)`
`default reactor.core.publisher.Mono<T>`
HttpMessageReader.`readMono(org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, ServerHttpRequest request, ServerHttpResponse response, Map<String,Object> hints)`
Server-side only alternative to `HttpMessageReader.readMono(ResolvableType, ReactiveHttpInputMessage, Map)` with additional, context available.
`reactor.core.publisher.Mono<Void>`
EncoderHttpMessageWriter.`write(Publisher<? extends T> inputStream, org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, MediaType mediaType, ServerHttpRequest request, ServerHttpResponse response, Map<String,Object> hints)`
`default reactor.core.publisher.Mono<Void>`
HttpMessageWriter.`write(Publisher<? extends T> inputStream, org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, MediaType mediaType, ServerHttpRequest request, ServerHttpResponse response, Map<String,Object> hints)`
Server-side only alternative to `HttpMessageWriter.write(Publisher, ResolvableType, MediaType, ReactiveHttpOutputMessage, Map)` with additional context available.
`reactor.core.publisher.Mono<Void>`
ResourceHttpMessageWriter.`write(Publisher<? extends org.springframework.core.io.Resource> inputStream, org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, MediaType mediaType, ServerHttpRequest request, ServerHttpResponse response, Map<String,Object> hints)`
`reactor.core.publisher.Mono<Void>`
ServerSentEventHttpMessageWriter.`write(Publisher<?> input, org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, MediaType mediaType, ServerHttpRequest request, ServerHttpResponse response, Map<String,Object> hints)`

## Uses of ServerHttpRequest in org.springframework.http.codec.json

Methods in org.springframework.http.codec.json with parameters of type ServerHttpRequest
Modifier and Type
Method
Description
`Map<String,Object>`
AbstractJackson2Decoder.`getDecodeHints(org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, ServerHttpRequest request, ServerHttpResponse response)`
`Map<String,Object>`
AbstractJackson2Encoder.`getEncodeHints(org.springframework.core.ResolvableType actualType, org.springframework.core.ResolvableType elementType, MediaType mediaType, ServerHttpRequest request, ServerHttpResponse response)`

## Uses of ServerHttpRequest in org.springframework.http.server.reactive

Classes in org.springframework.http.server.reactive that implement ServerHttpRequest
Modifier and Type
Class
Description
`class`
`AbstractServerHttpRequest`
Common base class for `ServerHttpRequest` implementations.
`class`
`ServerHttpRequestDecorator`
Wraps another `ServerHttpRequest` and delegates all methods to it.
Methods in org.springframework.http.server.reactive that return ServerHttpRequest
Modifier and Type
Method
Description
`ServerHttpRequest`
ServerHttpRequest.Builder.`build()`
Build a `ServerHttpRequest` decorator with the mutated properties.
`ServerHttpRequest`
ServerHttpRequestDecorator.`getDelegate()`
Methods in org.springframework.http.server.reactive with parameters of type ServerHttpRequest
Modifier and Type
Method
Description
`static <T> T`
ServerHttpRequestDecorator.`getNativeRequest(ServerHttpRequest request)`
Return the native request of the underlying server API, if possible, also unwrapping `ServerHttpRequestDecorator` if necessary.
`reactor.core.publisher.Mono<Void>`
ContextPathCompositeHandler.`handle(ServerHttpRequest request, ServerHttpResponse response)`
`reactor.core.publisher.Mono<Void>`
HttpHandler.`handle(ServerHttpRequest request, ServerHttpResponse response)`
Handle the given request and write to the response.
Constructors in org.springframework.http.server.reactive with parameters of type ServerHttpRequest
Modifier
Constructor
Description
``
`ServerHttpRequestDecorator(ServerHttpRequest delegate)`

## Uses of ServerHttpRequest in org.springframework.http.server.reactive.observation

Constructors in org.springframework.http.server.reactive.observation with parameters of type ServerHttpRequest
Modifier
Constructor
Description
``
`ServerRequestObservationContext(ServerHttpRequest request, ServerHttpResponse response, Map<String,Object> attributes)`
Create a new `ServerRequestObservationContext` instance.

## Uses of ServerHttpRequest in org.springframework.web.cors.reactive

Methods in org.springframework.web.cors.reactive with parameters of type ServerHttpRequest
Modifier and Type
Method
Description
`static boolean`
CorsUtils.`isCorsRequest(ServerHttpRequest request)`
Returns `true` if the request is a valid CORS one by checking `Origin` header presence and ensuring that origins are different via `CorsUtils.isSameOrigin(org.springframework.http.server.reactive.ServerHttpRequest)`.
`static boolean`
CorsUtils.`isPreFlightRequest(ServerHttpRequest request)`
Returns `true` if the request is a valid CORS pre-flight one by checking `OPTIONS` method with `Origin` and `Access-Control-Request-Method` headers presence.
`static boolean`
CorsUtils.`isSameOrigin(ServerHttpRequest request)`
Deprecated.
as of 5.2, same-origin checks are performed directly by `CorsUtils.isCorsRequest(org.springframework.http.server.reactive.ServerHttpRequest)`

## Uses of ServerHttpRequest in org.springframework.web.filter.reactive

Method parameters in org.springframework.web.filter.reactive with type arguments of type ServerHttpRequest
Modifier and Type
Method
Description
`UrlHandlerFilter.Builder.TrailingSlashSpec`
UrlHandlerFilter.Builder.TrailingSlashSpec.`intercept(Function<ServerHttpRequest,reactor.core.publisher.Mono<Void>> interceptor)`
Configure a request interceptor to be called just before the handler is invoked when a URL with a trailing slash is matched.

## Uses of ServerHttpRequest in org.springframework.web.server

Methods in org.springframework.web.server that return ServerHttpRequest
Modifier and Type
Method
Description
`ServerHttpRequest`
ServerWebExchange.`getRequest()`
Return the current HTTP request.
`ServerHttpRequest`
ServerWebExchangeDecorator.`getRequest()`
Methods in org.springframework.web.server with parameters of type ServerHttpRequest
Modifier and Type
Method
Description
`ServerWebExchange.Builder`
ServerWebExchange.Builder.`request(ServerHttpRequest request)`
Set the request to use especially when there is a need to override `ServerHttpRequest` methods.

## Uses of ServerHttpRequest in org.springframework.web.server.adapter

Methods in org.springframework.web.server.adapter that return ServerHttpRequest
Modifier and Type
Method
Description
`ServerHttpRequest`
ForwardedHeaderTransformer.`apply(ServerHttpRequest request)`
Apply and remove, or remove Forwarded type headers.
`ServerHttpRequest`
DefaultServerWebExchange.`getRequest()`
Methods in org.springframework.web.server.adapter with parameters of type ServerHttpRequest
Modifier and Type
Method
Description
`ServerHttpRequest`
ForwardedHeaderTransformer.`apply(ServerHttpRequest request)`
Apply and remove, or remove Forwarded type headers.
`protected ServerWebExchange`
HttpWebHandlerAdapter.`createExchange(ServerHttpRequest request, ServerHttpResponse response)`
`protected String`
HttpWebHandlerAdapter.`formatRequest(ServerHttpRequest request)`
Format the request for logging purposes including HTTP method and URL.
`reactor.core.publisher.Mono<Void>`
HttpWebHandlerAdapter.`handle(ServerHttpRequest request, ServerHttpResponse response)`
`protected boolean`
ForwardedHeaderTransformer.`hasForwardedHeaders(ServerHttpRequest request)`
Whether the request has any Forwarded headers.
Constructors in org.springframework.web.server.adapter with parameters of type ServerHttpRequest
Modifier
Constructor
Description
``
`DefaultServerWebExchange(ServerHttpRequest request, ServerHttpResponse response, WebSessionManager sessionManager, ServerCodecConfigurer codecConfigurer, LocaleContextResolver localeContextResolver)`
`protected`
`DefaultServerWebExchange(ServerHttpRequest request, ServerHttpResponse response, WebSessionManager sessionManager, ServerCodecConfigurer codecConfigurer, LocaleContextResolver localeContextResolver, org.springframework.context.ApplicationContext applicationContext)`